/*
 * Encoding.h
 *
 * Time-stamp: <04/08/30 11:09:46 lars>
 *
 * history: 2004/02/19  1.0  LST created.
 */

#ifndef __ENCODING__
#define __ENCODING__

/**
 * An Encoding / Ordering of items.
 *
 * @author Lars Schmidt-Thieme
 * @version 1.0
 */
class Encoding {

 public:
  int numItems;
  int numCodes;
  int* codes;        // map items --> codes. (maybe not injective: "merged items")
  int* itemByCode;   // map codes --> items. (injective: canonical representation)

  Encoding(int numItems);
  Encoding(int numItems, int numCodes, int* codes, int* itemByCode);
  ~Encoding();

  /**
   * Compute the encoding that results from first applying this encoding and
   * than the given encoding, i.e., code(item) = encoding.code(this.code(item)).
   */ 
  Encoding* concat(Encoding* encoding);

  void dump();

  //private:
  // bool arraysOwned;
  
};


#endif
