/*
 * IO.cpp
 *
 * Time-stamp: <04/09/07 16:07:41 lars>
 *
 * history: 2004/04/01  1.0  LST created.
 */

#include "IO.h"
#include "Sorting.h"

// #include <iostream>
// using namespace std;

#define OUTPUT_BUFFER_SIZE 100000

/**
   File output from lcm algorithm by Takeaki Uno. 
  */
char outputBuffer[OUTPUT_BUFFER_SIZE];

/**
 * Actual pattern sorted (input encoding).
 */
int patternSorted[MAX_PATTERN_LENGTH];




void writePattern_sorted(FILE *out, int* pattern, int length, int support) {
  // a. sort pattern:
  for (int i = 0; i < length; i++) 
    patternSorted[i] = pattern[i]; 
  quickSort(patternSorted, 0, length); 

  // b. write support:
  int pos = OUTPUT_BUFFER_SIZE, x;
  outputBuffer[--pos] = '\n';
  outputBuffer[--pos] = ')';
  x = support;
  while (x > 0) {
    outputBuffer[--pos] = x % 10 + '0';
    x /= 10;
  }
  outputBuffer[pos--] = '(';

  // c. write itemset:
  for (int i = length-1; i >= 0; i--) {
    outputBuffer[--pos] = ' ';
    x = patternSorted[i];
    if (x == 0) {
	outputBuffer[--pos] = '0';
    } else {
      while (x > 0) {
	outputBuffer[--pos] = x % 10 + '0';
	x /= 10;
      }
    }
  }
  // fwrite(&(outputBuffer[pos]), OUTPUT_BUFFER_SIZE - pos, 1, out);
  writePatternFile(out, &(outputBuffer[pos]), OUTPUT_BUFFER_SIZE - pos);
}

void writePattern_unsorted(FILE *out, int* pattern, int length, int support) {
  // a. write support:
  int pos = OUTPUT_BUFFER_SIZE, x;
  outputBuffer[--pos] = '\n';
  outputBuffer[--pos] = ')';
  x = support;
  while (x > 0) {
    outputBuffer[--pos] = x % 10 + '0';
    x /= 10;
  }
  outputBuffer[--pos] = '(';

  // b. write itemset:
  for (int i = length-1; i >= 0; i--) {
    outputBuffer[--pos] = ' ';
    x = pattern[i];
    if (x == 0) {
	outputBuffer[--pos] = '0';
    } else {
      while (x > 0) {
	outputBuffer[--pos] = x % 10 + '0';
	x /= 10;
      }
    }
  }
  // fwrite(&(outputBuffer[pos]), OUTPUT_BUFFER_SIZE - pos, 1, out);
  writePatternFile(out, &(outputBuffer[pos]), OUTPUT_BUFFER_SIZE - pos);
}

void writeEmptyPattern(FILE *out, int support) {
  // a. write support:
  int pos = OUTPUT_BUFFER_SIZE, x;
  outputBuffer[--pos] = '\n';
  outputBuffer[--pos] = ')';
  x = support;
  while (x > 0) {
    outputBuffer[--pos] = x % 10 + '0';
    x /= 10;
  }
  outputBuffer[--pos] = '(';
  // fwrite(&(outputBuffer[pos]), OUTPUT_BUFFER_SIZE - pos, 1, out);
  writePatternFile(out, &(outputBuffer[pos]), OUTPUT_BUFFER_SIZE - pos);
}


#if OUTPUT_MECHANISM == 1

int openOutputPatternFile(char* name) {
  int fd = open(name, O_WRONLY);
  ftruncate(fd, 0);
  return fd;
}

#endif
