/*
 * IntScanner.cpp
 *
 * Time-stamp: <04/06/03 12:17:55 lars>
 *
 * history: 2004/02/19  1.0  LST created.
 */
#include "IntScanner.h"

/**
 * Reads an inputstream of integers fast.
 *
 * @author Lars Schmidt-Thieme
 * @version 1.0
 */

IntScanner::IntScanner(istream* in) {
  this->in = in;

  bufferSize = DEFAULT_BUFFER_SIZE;

  buf = new char[bufferSize];
  bufLength = (*in).readsome(buf, bufferSize);
  pos = 0;
  while (((ch = buf[pos++]) < '0') || (ch > '9'))
    if (pos >= bufLength) {
      bufLength = (*in).readsome(buf, bufferSize);
      pos = 0;
    }
}

IntScanner::~IntScanner() {
  /*
  if (buf != 0) {
    cout << "  delete scanners buffer " << endl;
    delete[] buf;
  }
  */
}

bool IntScanner::hasNextInt() {
  return ch >= '0' && ch <= '9';
}
int IntScanner::nextInt() {
  int value = ch - '0';
  if (pos >= bufLength) {
    bufLength = (*in).readsome(buf, bufferSize);
    pos = 0;
  }
  while (((ch = buf[pos++]) >= '0') && (ch <= '9')) {
    value = value*10 + (ch - '0');
    if (pos >= bufLength) {
      bufLength = (*in).readsome(buf, bufferSize);
      pos = 0;
    }
  }
  if (pos >= bufLength) {
    bufLength = (*in).readsome(buf, bufferSize);
    pos = 0;
  }
  while (bufLength != 0 && (((ch = buf[pos++]) < '0') || (ch > '9'))) {
    if (pos >= bufLength) {
      bufLength = (*in).readsome(buf, bufferSize);
      pos = 0;
    }
  }
  return value;
}
